<?php

/**
 * @version 3.0.15
 * @author Flmngr
 * @copyright Copyright (c) 2024 EdSDK (https://flmngr.com/). All rights reserved.
 * @license GNU General Public License version 3 or later
 */

defined('_JEXEC') or die;// No direct access

class FlmngrController extends JControllerLegacy {

  /**
   * flmngr Method to display a file manager.
   *
   * @return json string or null
   */
  public function flmngr() {
    $user = JFactory::getUser();
    if ($user->authorise('core.edit', 'com_flmngr') == TRUE) {
      require JPATH_SITE . '/components/com_flmngr/libraries/file-manager/flmngr.php';
    }
    die();
  }

  /**
   *  Method for setting API key and access token from Flmngr in the article
   */
  public function setApiKey() {
    $user = JFactory::getUser();
    if ($user->authorise('core.edit', 'com_flmngr') == TRUE) {

      // Load the current component params.
      $params = JComponentHelper::getParams('com_flmngr');
      // Set new value of param(s)
      $params->set('api_key', $_POST["flmngrApiKey"] . ":" . $_POST["flmngrToken"]);

      // Save the parameters
      $componentid = JComponentHelper::getComponent('com_flmngr')->id;
      $table = JTable::getInstance('extension');
      $table->load($componentid);
      $table->bind(['params' => $params->toString()]);

      // check for error
      if (!$table->check()) {
        http_response_code(500);
        echo $table->getError();
        die;
      }
      // Save to database
      if (!$table->store()) {
        http_response_code(500);
        echo $table->getError();
        die;
      }
    }

    http_response_code(200);
    die();
  }

}